import QtQuick 1.0


Item {
    id: attachmentBrowserDelegateItem
    //width: attachmentGrid.cellWidth; height: attachmentGrid.cellHeight

    property variant delegateData: model

//    Keys.enabled: true
//    Keys.onSpacePressed: closeWindow();

    MouseArea {
        id: attachmentBrowserDelegateMouseArea

        anchors.fill: parent
        onClicked: {
            attachmentGrid.currentIndex = index
            previewArea.loadPreview(uid,url,att_type);
        }
        onDoubleClicked: {
//            console.debug("Item Double Clicked -> Starting external viewer")
//            console.debug(url)
//            console.debug(name)
//            console.debug(iconpath)
//            console.debug(uid)
//            console.debug(att_type)

            QtHandler.openExternalViewerForAttachment(uid)
        }
    }

    states: [
        State {
            name: "selected"
            when: attachmentBrowserDelegateItem.GridView.isCurrentItem
            PropertyChanges {
                target: attachmentBrowserRect;
                color: "#33ffffff";
            }
        }

    ]

    Rectangle {
        id: attachmentBrowserDelegateColumn
        anchors.fill: parent
        anchors.topMargin: 2
        anchors.bottomMargin: 2
        anchors.leftMargin: 1
        anchors.rightMargin: 1
        color: "transparent"

        Image {
            id: clearButton
            anchors.right: parent.right
            anchors.rightMargin: 2
            anchors.top: parent.top
            anchors.topMargin: 2
            width: 12
            height: 12

            source: "imports/XAComponents/pics/PreviewIconCloseButtonFlat12px.png"
            visible: (attachmentGrid.currentIndex === index)

            MouseArea {
                anchors.fill: parent
                hoverEnabled: true

                onEntered: clearButton.source = "imports/XAComponents/pics/PreviewIconCloseButton12px.png"
                onExited: clearButton.source = "imports/XAComponents/pics/PreviewIconCloseButtonFlat12px.png";
                onClicked: QtHandler.removeAttachment(uid);
            }
        }

        Image {
            source: iconpath;
            anchors.horizontalCenter: parent.horizontalCenter;
            smooth: true
            width: 32
            height:  32
            anchors.top: parent.top
            anchors.topMargin: 10
        }

        Text {
            id: urlSegment
            //text: url;
            //font.family: "Helvetica, Helveltica, Arial";
            font.family: "Arial";
            font.bold: false;
            font.pixelSize: 9;
            anchors.horizontalCenter: parent.horizontalCenter;
            width: 70
            clip: true
            color: "black"
            smooth: true;
            anchors.top: parent.top
            anchors.topMargin: 42
            elide: Text.ElideLeft
            horizontalAlignment: Text.AlignHCenter

            MouseArea {
                anchors.fill: parent
                hoverEnabled: true

                onEntered: urlToolTip.visible=true;
                onExited: urlToolTip.visible=false;

                onClicked: attachmentBrowserDelegateMouseArea.clicked("")
            }
        }

        Rectangle {
            id: urlToolTip
            visible: false

            anchors.verticalCenter: urlSegment.verticalCenter
            anchors.horizontalCenter: urlSegment.horizontalCenter
            anchors.verticalCenterOffset: -1

            width: urlToolTipText.width+6
            height: urlToolTipText.height+2

            border.width: 1
            border.color: "gray"
            radius: 6

            color: "#ffffeb"

            Text {
                anchors.verticalCenter: parent.verticalCenter
                anchors.horizontalCenter: parent.horizontalCenter
                id: urlToolTipText;
                text: url
                font.family: "Arial";
                font.bold: false;
                font.pixelSize: 10;
                color: "black"
                smooth: true;
            }
        }

        Text {
            text: name;
            //font.family: "Helvetica, Helveltica, Arial";
            font.family: "Arial";
            font.bold: true;
            font.pixelSize: 11;
            anchors.horizontalCenter: parent.horizontalCenter;
            color: (attachmentGrid.currentIndex === index) ? "white" : "black"
            smooth: true;
            anchors.top: parent.top
            anchors.topMargin: 55
        }
    }

    Component.onCompleted: {
        var displayurl = "";
        var baseurl;

        if (url.length > 8) {
            if (url.substr(0,7) == "http://") {
                baseurl = url.substring(7);
                displayurl = baseurl.substring(0, baseurl.indexOf("/"))

            } else if (url.substr(0,8) == "https://") {
                baseurl = url.substring(8);
                displayurl = baseurl.substring(0, baseurl.indexOf("/"))

            } else displayurl = url;
        }

        urlSegment.text = displayurl
    }
}

