// import QtQuick 1.0 // to target S60 5th Edition or Maemo 5
import QtQuick 1.1
import "../imports/XAComponents"
import "../Map"

Item {
    id: maincomponent

    property int itemAIDType: 0

    property bool isEditable: false

    property bool isEditing: false
    property bool isModified: false
    property bool isSelected: false

    signal triggered(int newAIDType);

    property color tabPanelMarkerColor: "#639fff"
    property Gradient tabPanelBackgroundGradient: Gradient {
        GradientStop { position: 0.0; color: "white" }
        GradientStop { position: 0.5; color: "#dddddd" }
        GradientStop { position: 1.0; color: "white" }
    }

    onItemAIDTypeChanged:  {
        detailsPanel.selectTab(itemAIDType)
        triggered(itemAIDType)
    }

    Rectangle {
        id: detailsPanel
        anchors.fill: parent

        color: "transparent"

        property int tabWidths: 120
        property int tabHeights: 21
        property int tabCount: 3

        property int tabStartPos: (detailsPanel.width / 2 - (detailsPanel.tabCount * detailsPanel.tabWidths / 2))

        function selectTab(tab) {
            tab0.isSelected = false
            tab1.isSelected = false
            tab2.isSelected = false

            if (tab === 0) tab0.isSelected = true
            if (tab === 1) tab1.isSelected = true
            if (tab === 2) tab2.isSelected = true
        }

        AIInspectorTabPanelTab {
            id: tab0
            anchors.top: parent.top
            height: detailsPanel.tabHeights
            width: detailsPanel.tabWidths
            anchors.left: parent.left
            anchors.leftMargin: detailsPanel.tabStartPos

            backgroundColor: "white"
            selectionColor: tabPanelMarkerColor

            text: qsTr("Action")
//            icon: "qrc:/icons/PriorityDotsLow.png"
//            iconVisible: true
            isSelected: true

            onTriggered: {
                console.debug("Action triggered.")
//                detailsPanel.selectTab(0)
                itemAIDType = 0
            }
        }

        AIInspectorTabPanelTab {
            id: tab1
            anchors.top: parent.top
            height: detailsPanel.tabHeights
            width: detailsPanel.tabWidths
            anchors.left: parent.left
            anchors.leftMargin: detailsPanel.tabStartPos + width

            backgroundColor: "white"
            selectionColor: tabPanelMarkerColor

            text: qsTr("Information")
//            icon: "qrc:/icons/PriorityDotsNormal.png"

            onTriggered: {
                console.debug("Information triggered.")
//                detailsPanel.selectTab(1)
                itemAIDType = 1
            }
        }

        AIInspectorTabPanelTab {
            id: tab2
            anchors.top: parent.top
            height: detailsPanel.tabHeights
            width: detailsPanel.tabWidths
            anchors.left: parent.left
            anchors.leftMargin: detailsPanel.tabStartPos + width * 2

            backgroundColor: "white"
            selectionColor: tabPanelMarkerColor

            text: qsTr("Decision")
//            icon: "qrc:/icons/PriorityDotsMedium.png"

            onTriggered: {
                console.debug("Decision triggered.")
//                detailsPanel.selectTab(2)
                itemAIDType = 2
            }
        }

    }
}
